#ifdef __GNUG__
#pragma interface
#endif

#ifndef YOO_WIDGET_HXX
#define YOO_WIDGET_HXX

#include <Mrm/MrmPublic.h>
#include <Xm/Xm.h>
#include "list.hxx"

#define WIDGET_CONTROL_OK 0
#define WIDGET_CONTROL_KO -1 

class YooWidget {
  
  private :
  
  int _error_wc ;
  
  Widget _w_racine ;
  XtAppContext _app_context ;

  const int _name_max = 25 ;
  int _name_i ;
  MrmRegisterArg _name[_name_max] ;

  public :

  void _widgetClassName(Widget w,
			char* widget_class,
			char* widget_name,
			int& widget_class_pos,
			int& widget_name_pos,
			int widget_len) ;
  
  void _widgetName(Widget w,
		   char* widget_name,
		   int& widget_name_pos,
		   int widget_len) ;
  
  void _resClassName(char* res_class,
		     char* res_name,
		     char* cn_class,
		     char* cn_name,
		     int cn_len) ;

  YooWidget(XtAppContext app=NULL,
		 Widget w=NULL)  ;

  void app_context(XtAppContext app) { _app_context= app ; } ;
  void w_racine(Widget w) {
    _w_racine= w ;
  } ;
  int  register_name(char *name, XtPointer proc) ;
  void register_name(MrmRegisterArg t[], int t_count) ;

  XtAppContext app_context() { return _app_context ; } ;
  Widget w_racine() { return _w_racine ; } 
  
  int error_wc() { int res = _error_wc;
		   _error_wc = WIDGET_CONTROL_OK;
		   return res ; } ;
  
  int exist(char* nhp) ;  
  int show(char* nhp) ;    
  int hide(char* nhp) ;    
  int enable(char* nhp) ;  
  int disable(char* nhp) ;
  
  int set_text(char* nhp,char* text) ; 
  char* get_text(char* nhp) ;
  
  int set_text(Widget w,char* text) ; 
  char* get_text(Widget w) ;
  
  int set_scale_value(char* nhp,int val) ; 
  int get_scale_value(char* nhp) ;

  int set_choice_text(char* nhp, const ListVal<char*>& l_item) ;
  ListVal<char*> get_choice_text(char* nhp) ;
  int set_choice_selection(char* nhp, const ListVal<int>& l_sel) ;
  ListVal<int> get_choice_selection(char* nhp) ;

  int set_state(char* nhp,int state) ;
  int get_state(char* nhp) ;

  int fetch(char* nhp_pere,
	    char* n_fetch,char* n_modele,char* fichier_uid) ;
  int fetch_toplevel(char* titre,
		     char* n_top,char* n_modele,char* fichier_uid) ;

  char* get_name(char* nhp) ;
  int   destroy(char* nhp) ;
} ;

extern YooWidget* YOO_WidgetControl ;

#endif /* YOO_WIDGET_HXX */







